/*

 Servo powered by a push button

 Moves a servo by a number of degrees, connected to digital pin 2,
 when pressing a pushbutton.
 The servo is connected to digital pin 3.
 
 Pushbutton is connected to pin 2 and ground
 Servo is connected to 3 with a separate power supply to reduce the load on the Arduino.

 Coded by Neil Williamson using sections of code created by Tim King
 from elementsw from 21 Jan 2010 by Tom Igoe including  'debounce' button code
 plus INPUT_PULLUP content from left mouse click code for foot operated switch
 very simple from apcmag.com author Darren Yates January 9, 2014
 
*/

#include<Servo.h>

Servo Myservo;
int pos=0;

const int buttonPin = 2;    // the pin number of the input pushbutton pin
const int servoPin = 3;    // to send signal to Servo
const int PressTime = 300;  // the time the button signal is activated

// variables will change:
int playState = LOW;         // the current state of the output pin
int buttonState = HIGH;       // the current reading from the input pin - active output when LOW
int lastButtonState = LOW;   // the previous reading from the input pin
int heldOn = 0;             // changes to 1 if button held down all the time

// the following variables are long's because the time, measured in miliseconds,
// will quickly become a bigger number than can be stored in an int.
long lastDebounceTime = 0;  // the last time the output pin was toggled
long debounceDelay = 50;    // the debounce time; increase if the output flickers

void setup() {

  // to allow signal information to be seen in monitor window for troubleshooting
  Serial.begin(9600);

  // avoid need for resistor but using pullup
  pinMode(buttonPin, INPUT_PULLUP);

  // define output pins
  pinMode(servoPin, OUTPUT);
  
  //  pinMode(2,INPUT);
  Myservo.attach(3);
}

void loop()
{
  // see if input button is pressed and check for debounce:
  // read the state of the switch into a local variable:
  int reading = digitalRead(buttonPin);
  if (reading == HIGH) {
    heldOn = 0;
  }
  // check to see if you just pressed the button
  // (i.e. the input went from LOW to HIGH),  and you've waited
  // long enough since the last press to ignore any noise:

  // If the switch changed, due to noise or pressing:
  if (reading != lastButtonState) {
    // reset the debouncing timer
    lastDebounceTime = millis();
  }

  if ((millis() - lastDebounceTime) > debounceDelay) {
    // whatever the reading is at, it's been there for longer
    // than the debounce delay, so take it as the actual current state:

    // if the button state has changed:
    if (reading != buttonState) {
      buttonState = reading;

      // only activate the servo if the new button state is LOW
      if (buttonState == LOW) {

        // activate the PLAY signal output to simulate pressing a remote control play button
        if (heldOn == 0) {
          Serial.println("Sending Go code ");
          delay(50);

         if(digitalRead(2)==HIGH){
         Myservo.write(0);
         }
         else
         Myservo.write(16);

          // read the state of the switch into a local variable:
          int reading = digitalRead(buttonPin);
          if (reading == LOW) {
            heldOn = 1;
          }
          else {
            (heldOn == 0);
          }
        }
      }
    }


  }

  // save the reading.  Next time through the loop,
  // it'll be the lastButtonState:
  lastButtonState = reading;

}
